=== engine/Makefile ===
#
# Turtle Arena Makefile
#
# GNU Make required
#

# ioq3ztm svn version that this is based on
IOQ3ZTM_REVISION = 113

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/i386/)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif

ifeq ($(COMPILE_PLATFORM),mingw32)
  ifeq ($(COMPILE_ARCH),i386)
    COMPILE_ARCH=x86
  endif
  ifeq ($(COMPILE_ARCH),x86_64)
    COMPILE_ARCH=x64
  endif
endif

ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_CLIENT_SMP
  BUILD_CLIENT_SMP =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     =
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   =
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_MISSIONPACK
  BUILD_MISSIONPACK=0
endif
ifndef BUILD_FINAL
  BUILD_FINAL      =0
endif

ifneq ($(PLATFORM),darwin)
  BUILD_CLIENT_SMP = 0
endif


###################################################################
# Default Turtle Arena config
#  - All of this can be overriden by Makefile.local
###################################################################

# Some of the defines aren't as independent as they should be, TA_WEAPSYS requires TA_PLAYERSYS, etc
# Please note: TA_*SYS defines are general system changes, not 'totally' specifiy for Turtle Arena

##### ioquake3 defines
# RAVENMD4				Enable support for loading MDR models.
# MISSIONPACK			Code for the official Quake III Arena expansion pack, Quake III: Team Arena.
##### Split from MISSIONPACK define
# MISSIONPACK_HUD		Use MISSIONPACK UI scripting in cgame for hud and menus.
# MISSIONPACK_HARVESTER	Enable MISSIONPACK harvester gametype


# Turtle Arena "general" defines
#####
# IOQ3ZTM				ZTurtleMan's misc changes and fixes to ioquake3 (might be q3 mod compatible)
# IOQ3ZTM_NO_COMPAT		Changes that are not compatible with quake3 mods
#
#   DAMAGE_SKINS; Allows player skins to have shaders to use when damaged.
#       Adds a new var "skinFraction" to entityState_t and refEntity_t
#
# IOQ3ZTM_NO_TEAM_MODEL	Removes team_model and team_headmodel cvars. (Could break Quake III: Team Arena and other mods?)
#####
# NOTRATEDM				Disable stuff in Quake3 engine that made it rated M. (default blood to off, remove gibs,
#							remove strong lang) This however doesn't change the gamedata, like the botfiles strong lang,
#							bloody textures, netgamers, etc NOTE: This can be defined without defining "NOBLOOD"
#							ZTM: TODO: Rename this define to ...?
# NOBLOOD				Removes blood. If this is defined, NOTRATEDM must also be defined.
# TA_BLOOM				Post-process bloom light effect, based on code from OpenArena.
#####
# TA_ITEMSYS			Load items from external text files. Required for TA_WEAPSYS.
# TA_ITEMSYS_USE_INTERNAL Use the internal item data. The data can be overriden by external items.
# TA_WEAPSYS			This is the core changes to the weapon system
#							loads the weapons from a text file, allowing for easy modifing,
#							and new custom default weapons for players.
# TA_WEAPSYS_EX			Changes from holding multiple weapons to only one default and one pickup.
# TA_WEAPSYS_EX_COMPAT	Keeps compatibility with mods not using TA_WEAPSYS_EX
# TA_GAME_MODELS		Allow "game" to use model tags. Player tags are used for melee weapon attacking.
# TA_HOLDSYS			Allow players to hold multiple holdable items and change to any holdable.
#							(Based on Q3's weapon changing)
# TA_PLAYERSYS			Allows player config to be used in "game", allowing for per-player settings.
# TA_PATHSYS			General path system using entities like path_corner
# TA_ENTSYS				Adds new entities and allows all ET_MOVER entities to be breakable.
# TA_NPCSYS   			WIP NPC system, based on TDC_NPC system and code in Quake3
# TA_ATMEFFECTS			TODO: Atmospheric effects.
# TA_SUPPORTQ3			Support falling back to Quake3 player tags, shader names, and stuff...
#							Currently required as my players use Q3 tag_weapon instead of Turtle Arena tag_hand_primary...
# TA_SPLITVIEW			Allow a single game client to connect and play using multiple local clients, commonly called splitscreen.
#						TODO: Split view system for viewing multiple network clients at once.


# Turtle Arena specific defines
#####
# TURTLEARENA			Turtle Arena game logic changes
# TA_MISC				Stuff that I don't want in ioq3ztm, but would use in another standalone mod
#							(Like a NiGHTS into Dreams clone or Sonic Robo Blast Arena...)
# TA_SP					Single player / co-op mode code
# TA_DATA				Changes for Turtle Arena data.
#####
# NIGHTSMODE			Hardly started NiGHTS into Dreams mode.

BUILD_DEFINES = -DNOTRATEDM -DNOBLOOD \
					-DIOQ3ZTM -DIOQ3ZTM_NO_COMPAT -DIOQ3ZTM_NO_TEAM_MODEL \
					-DTA_HOLDSYS -DTA_ITEMSYS \
					-DTA_WEAPSYS -DTA_PLAYERSYS \
					-DTA_SUPPORTQ3 -DTA_ENTSYS -DTA_NPCSYS -DTA_PATHSYS \
					-DTA_WEAPSYS_EX_COMPAT \
					-DTA_BLOOM -DTA_SPLITVIEW

BUILD_DEFINES += -DTURTLEARENA -DTA_MISC -DTA_SP \
					-DTA_WEAPSYS_EX -DTA_DATA \
					-DNIGHTSMODE

# Use model tags for true melee attacking
DED_USE_MODELS=1
BUILD_DEFINES += -DTA_GAME_MODELS

# Turtle Arena's intro video will be ogg theora
USE_CODEC_THEORA=1

# Turtle Arena currently just keeps renderer internal
ifneq ($(USE_RENDERER_DLOPEN), 1)
	USE_RENDERER_DLOPEN=0
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=0.6.1
endif

ifndef CLIENTBIN
CLIENTBIN=turtlearena
endif

ifndef SERVERBIN
SERVERBIN=turtlearena-server
endif

ifndef BASEGAME
BASEGAME=base
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=-DMISSIONPACK
endif

ifndef MISSIONPACK
MISSIONPACK=missionpack
endif

ifndef MISSIONPACK_CFLAGS
MISSIONPACK_CFLAGS=-DMISSIONPACK -DMISSIONPACK_HUD # -DMISSIONPACK_HARVESTER
endif

# Add "-DEXAMPLE" to define EXAMPLE in engine and game/cgame/ui.
ifndef BUILD_DEFINES
BUILD_DEFINES =
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/turtlearena"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=1
endif

ifndef USE_CURL_DLOPEN
  ifeq ($(PLATFORM),mingw32)
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=1
endif

ifndef USE_CODEC_THEORA
USE_CODEC_THEORA=0
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_INTERNAL_SPEEX
USE_INTERNAL_SPEEX=1
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=1
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=1
endif

ifndef USE_INTERNAL_FREETYPE
USE_INTERNAL_FREETYPE=1
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=1
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

ifndef USE_OLD_VM64
USE_OLD_VM64=0
endif

#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RDIR=$(MOUNT_DIR)/renderer
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
Q3UIDIR=$(MOUNT_DIR)/q3_ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
SPEEXDIR=$(MOUNT_DIR)/libspeex
ZDIR=$(MOUNT_DIR)/zlib
FTDIR=$(MOUNT_DIR)/freetype-2.4.9
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
LOKISETUPDIR=misc/setup
NSISDIR=misc/nsis
SDLHDIR=$(MOUNT_DIR)/SDL12
LIBSDIR=$(MOUNT_DIR)/libs
OGGDIR=$(MOUNT_DIR)/libogg
VORBISDIR=$(MOUNT_DIR)/libvorbis
THEORADIR=$(MOUNT_DIR)/libtheora

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS=$(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS=$(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS=$(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS=$(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS=$(shell pkg-config --silence-errors --cflags sdl|sed 's/-Dmain=SDL_main//')
    SDL_LIBS=$(shell pkg-config --silence-errors --libs sdl)
    FREETYPE_CFLAGS=$(shell pkg-config --silence-errors --cflags freetype2)
  endif
  # Use sdl-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl-config),)
      SDL_CFLAGS=$(shell sdl-config --cflags)
      SDL_LIBS=$(shell sdl-config --libs)
    endif
  endif
endif

ifneq ($(BUILD_FINAL),1)
	# Add svn version info
	USE_SVN=
	ifeq ($(wildcard .svn),.svn)
	  SVN_REV=$(shell LANG=C svnversion .)
	  ifneq ($(SVN_REV),)
		VERSION:=$(VERSION)_SVN$(SVN_REV)
		USE_SVN=1
	  endif
	else
	ifeq ($(wildcard .git/svn/.metadata),.git/svn/.metadata)
	  SVN_REV=$(shell LANG=C git svn info | awk '$$1 == "Revision:" {print $$2; exit 0}')
	  ifneq ($(SVN_REV),)
		VERSION:=$(VERSION)_SVN$(SVN_REV)
	  endif
	endif
	endif

	ifdef IOQ3ZTM_REVISION
	  VERSION:=$(VERSION)_IOQ3ZTMr$(IOQ3ZTM_REVISION)
	endif
endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
LIB=lib

INSTALL=install
MKDIR=mkdir

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu"))

  ifeq ($(ARCH),axp)
    ARCH=alpha
  else
  ifeq ($(ARCH),x86_64)
    LIB=lib64
  else
  ifeq ($(ARCH),ppc64)
    LIB=lib64
  else
  ifeq ($(ARCH),s390x)
    LIB=lib64
  endif
  endif
  endif
  endif

  BASE_CFLAGS = -Wall -fno-strict-aliasing -Wimplicit -Wstrict-prototypes \
    -pipe -DUSE_ICON
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3 -funroll-loops -fomit-frame-pointer
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3 -fomit-frame-pointer -funroll-loops \
      -falign-loops=2 -falign-jumps=2 -falign-functions=2 \
      -fstrength-reduce
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
    HAVE_VM_COMPILED = true
  else
  ifeq ($(ARCH),i386)
    OPTIMIZEVM = -O3 -march=i586 -fomit-frame-pointer \
      -funroll-loops -falign-loops=2 -falign-jumps=2 \
      -falign-functions=2 -fstrength-reduce
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
    HAVE_VM_COMPILED=true
  else
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
