=== debian_main/data/debian/changelog ===
turtlearena-data (0.6.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 14 Aug 2012 16:07:52 +0600

turtlearena-data (0.6-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Mon, 9 Apr 2012 15:07:04 +0600

turtlearena-data (0.5.3-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 23 Dec 2011 12:17:56 +0600

turtlearena-data (0.5.2-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 14 Aug 2011 18:36:22 +0500

turtlearena-data (0.5.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 30 Jul 2011 20:24:33 +0500

turtlearena-data (0.5.0-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 9 Mar 2011 22:19:59 +0500

turtlearena-data (0.5.0-0~lucid1) lucid; urgency=low

  * Development release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 9 Mar 2011 22:19:59 +0500

turtlearena-data (0.4.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 4 Jan 2011 00:22:23 +0500

turtlearena-data (0.4-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 30 Dec 2010 11:43:20 +0500

turtlearena-data (0.2-1) lucid; urgency=low

  * Initial release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 28 May 2010 13:01:28 +0500
