=== debian_main/wiimote/debian/changelog ===
turtlearena-wiimote (0.2-1~lucid1) lucid; urgency=low

  * Initial release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 10 Dec 2010 15:41:25 +0500
