=== debian_main/data/debian/control ===
Source: turtlearena-data
Section: games
Priority: optional
Maintainer: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Uploaders: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.8.0
Homepage: http://turtlearena.googlecode.com/

Package: turtlearena-data
Architecture: all
Depends: ${misc:Depends}
Recommends: turtlearena (>= ENGINE_VERSION) | turtlearena-server (>= ENGINE_VERSION)
Description: Turtle Arena data files
 Turtle Arena is an free and open source 3D third person action game based on
 ioquake3. It is a free stand-alone game.
 .
 This package installs the Turtle Arena data files required to play the game or run a server.
