=== debian_main/wiimote/debian/control ===
Source: turtlearena-wiimote
Section: games
Priority: optional
Maintainer: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Uploaders: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.8.0
Homepage: http://turtlearena.googlecode.com/

Package: turtlearena-wiimote
Architecture: all
Depends: ${misc:Depends}, wminput
Recommends: turtlearena (>= ${source:Upstream-Version})
Description: Turtle Arena Wiimote support
 Turtle Arena is an open-source Ninja Turtle fangame based on ioquake3. It
 is licensed under the GPL. It is a free stand-alone game.
 .
 This package installs the Turtle Arena Wiimote wminput config and launchers.
